using Avalonia.Controls;
using Avalonia.Input;
using Avalonia.Interactivity;
using Chapplication.Models;
using Chapplication.Networking;

namespace Chapplication;

public partial class MainWindow : Window
{
    private NetworkManager _networkManager = new();
    
    public MainWindow()
    {
        InitializeComponent();

        _networkManager.MessageRecieved += RecieveMessage;
    }

    private void SubmitButton_OnClick(object? sender, RoutedEventArgs e)
    {
        SendMessage();
    }

    private void ChatInputBox_OnKeyDown(object? sender, KeyEventArgs e)
    {
        if (e.Key == Key.Enter)
        {
            SendMessage();
        }
    }

    private void AddMessage(string message)
    {
        ChatInputBox.Text = string.Empty;
        
        //_currentConversation.Messages.Add(message);
        ChatBox.Items.Add(message);
        
        ChatInputBox.Focus();
    }
    
    private void SendMessage()
    {
        if (string.IsNullOrWhiteSpace(ChatInputBox.Text))
        {
            return;
        }
        
        var msg = new Message() {Content = $"me: {ChatInputBox.Text}"}; 
        AddMessage(msg.Content);
        
        _networkManager.SendMessage(msg.ToString(), "127.0.0.1", 5001);
        
    }

    private void RecieveMessage(object? sender, string s)
    {
        AddMessage(s);
    }
}