using System;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;

namespace Chapplication.Networking;

public class NetworkManager
{

    public event EventHandler<string>? MessageRecieved;
    private readonly UdpClient _client = new(5000);

    public NetworkManager()
    {
        MessageRecieved += (s, message) =>
        {
            Console.WriteLine("Recieved message");
            Console.WriteLine(message);
        };
        
        BeginRecieve();
        
    }

    public void BeginRecieve()
    {
        Task.Run(async () =>
        {
            try
            {
                while (true)
                {
                    var result = await _client.ReceiveAsync();
                    MessageRecieved?.Invoke(this, Encoding.UTF8.GetString(result.Buffer));
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e);
            }
        });
    }

    public void SendMessage(string message, string remoteIp, int remotePort)
    {
        var bytes = Encoding.UTF8.GetBytes(message);
        _client.SendAsync(bytes, remoteIp, remotePort);
    }

}